Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 74430)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -24,8 +24,6 @@
 #endif
 #endif
 
-static NTSTATUS get_inode_dir_path(device_extension* Vcb, root* subvol, UINT64 inode, PUNICODE_STRING us, PIRP Irp);
-
 static NTSTATUS STDCALL set_basic_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
     FILE_BASIC_INFORMATION* fbi = Irp->AssociatedIrp.SystemBuffer;
     fcb* fcb = FileObject->FsContext;
@@ -105,7 +103,8 @@
         LARGE_INTEGER time;
         BTRFS_TIME now;
         
-        defda = get_file_attributes(Vcb, &fcb->inode_item, fcb->subvol, fcb->inode, fcb->type, fileref->filepart.Length > 0 && fileref->filepart.Buffer[0] == '.', TRUE, Irp);
+        defda = get_file_attributes(Vcb, fcb->subvol, fcb->inode, fcb->type, fileref->dc && fileref->dc->name.Length >= sizeof(WCHAR) && fileref->dc->name.Buffer[0] == '.',
+                                    TRUE, Irp);
         
         if (fcb->type == BTRFS_TYPE_DIRECTORY)
             fbi->FileAttributes |= FILE_ATTRIBUTE_DIRECTORY;
@@ -219,6 +218,12 @@
     ExReleaseResourceLite(fcb->Header.Resource);
     
     ExReleaseResourceLite(&Vcb->fcb_lock);
+    
+    // send notification that directory is about to be deleted
+    if (NT_SUCCESS(Status) && fdi->DeleteFile && fcb->type == BTRFS_TYPE_DIRECTORY) {
+        FsRtlNotifyFullChangeDirectory(Vcb->NotifySync, &Vcb->DirNotifyList, FileObject->FsContext,
+                                       NULL, FALSE, FALSE, 0, NULL, NULL, NULL);
+    }
 
     return Status;
 }
@@ -251,7 +256,7 @@
     
     // FIXME - we can skip a lot of this if the inode is about to be deleted
     
-    fcb = create_fcb(PagedPool); // FIXME - what if we duplicate the paging file?
+    fcb = create_fcb(Vcb, PagedPool); // FIXME - what if we duplicate the paging file?
     if (!fcb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
@@ -323,7 +328,7 @@
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
         
         if (!ext->ignore) {
-            extent* ext2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+            extent* ext2 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
             
             if (!ext2) {
                 ERR("out of memory\n");
@@ -334,18 +339,8 @@
             ext2->offset = ext->offset;
             ext2->datalen = ext->datalen;
             
-            if (ext2->datalen > 0) {
-                ext2->data = ExAllocatePoolWithTag(PagedPool, ext2->datalen, ALLOC_TAG);
-                
-                if (!ext2->data) {
-                    ERR("out of memory\n");
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                RtlCopyMemory(ext2->data, ext->data, ext2->datalen);
-            } else
-                ext2->data = NULL;
+            if (ext2->datalen > 0)
+                RtlCopyMemory(&ext2->extent_data, &ext->extent_data, ext2->datalen);
             
             ext2->unique = FALSE;
             ext2->ignore = FALSE;
@@ -353,9 +348,9 @@
             
             if (ext->csum) {
                 ULONG len;
-                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
+                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
                 
-                if (ext->data->compression == BTRFS_COMPRESSION_NONE)
+                if (ext->extent_data.compression == BTRFS_COMPRESSION_NONE)
                     len = ed2->num_bytes;
                 else
                     len = ed2->size;
@@ -424,8 +419,6 @@
         le = le->Flink;
     }
     
-    fcb->last_dir_index = oldfcb->last_dir_index;
-    
     if (oldfcb->reparse_xattr.Buffer && oldfcb->reparse_xattr.Length > 0) {
         fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = oldfcb->reparse_xattr.Length;
         
@@ -451,6 +444,8 @@
         
         RtlCopyMemory(fcb->ea_xattr.Buffer, oldfcb->ea_xattr.Buffer, fcb->ea_xattr.Length);
     }
+    
+    fcb->prop_compression = oldfcb->prop_compression;
 
 end:
     *pfcb = fcb;
@@ -466,417 +461,47 @@
     LIST_ENTRY list_entry;
 } move_entry;
 
-static NTSTATUS add_children_to_move_list(move_entry* me, PIRP Irp) {
+static NTSTATUS add_children_to_move_list(device_extension* Vcb, move_entry* me, PIRP Irp) {
     NTSTATUS Status;
-    KEY searchkey;
-    traverse_ptr tp;
-    BOOL b;
     LIST_ENTRY* le;
-    move_entry* me2;
-    
-    static char xapref[] = "user.";
-    ULONG xapreflen = strlen(xapref);
-    
-    ExAcquireResourceSharedLite(&me->fileref->nonpaged->children_lock, TRUE);
-    
-    le = me->fileref->children.Flink;
-    while (le != &me->fileref->children) {
-        file_ref* fr = CONTAINING_RECORD(le, file_ref, list_entry);
-        
-        if (!fr->deleted) {
-            me2 = ExAllocatePoolWithTag(PagedPool, sizeof(move_entry), ALLOC_TAG);
-            if (!me2) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end;
-            }
-            
-            me2->fileref = fr;
-            
-            increase_fileref_refcount(fr);
 
-            me2->dummyfcb = NULL;
-            me2->dummyfileref = NULL;
-            me2->parent = me;
-            
-            InsertHeadList(&me->list_entry, &me2->list_entry);
-        }
-        
-        le = le->Flink;
-    }
+    ExAcquireResourceSharedLite(&me->fileref->fcb->nonpaged->dir_children_lock, TRUE);
     
-    searchkey.obj_id = me->fileref->fcb->inode;
-    searchkey.obj_type = TYPE_XATTR_ITEM;
-    searchkey.offset = 0;
+    le = me->fileref->fcb->dir_children_index.Flink;
     
-    Status = find_item(me->fileref->fcb->Vcb, me->fileref->fcb->subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
-    
-    do {
-        traverse_ptr next_tp;
+    while (le != &me->fileref->fcb->dir_children_index) {
+        dir_child* dc = CONTAINING_RECORD(le, dir_child, list_entry_index);
+        file_ref* fr;
+        move_entry* me2;
         
-        if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
-            DIR_ITEM* xa = (DIR_ITEM*)tp.item->data;
-            ULONG len;
-            
-            if (tp.item->size < sizeof(DIR_ITEM)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            len = tp.item->size;
-            
-            do {
-                if (len < sizeof(DIR_ITEM) - 1 + xa->m + xa->n) {
-                    ERR("(%llx,%x,%llx) was truncated\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                    Status = STATUS_INTERNAL_ERROR;
-                    goto end;
-                }
-                
-                if (xa->n > xapreflen && RtlCompareMemory(xa->name, xapref, xapreflen) == xapreflen &&
-                    (tp.item->key.offset != EA_DOSATTRIB_HASH || xa->n != strlen(EA_DOSATTRIB) || RtlCompareMemory(xa->name, EA_DOSATTRIB, xa->n) != xa->n) &&
-                    (tp.item->key.offset != EA_EA_HASH || xa->n != strlen(EA_EA) || RtlCompareMemory(xa->name, EA_EA, xa->n) != xa->n)
-                ) {
-                    BOOL found = FALSE;
-                
-                    le = me->fileref->children.Flink;
-                    
-                    while (le != &me->fileref->children) {
-                        file_ref* fr = CONTAINING_RECORD(le, file_ref, list_entry);
-
-                        if (fr->fcb->ads && fr->fcb->adshash == tp.item->key.offset && fr->fcb->adsxattr.Length == xa->n &&
-                            RtlCompareMemory(fr->fcb->adsxattr.Buffer, xa->name, xa->n) == xa->n) {
-                            found = TRUE;
-                            break;
-                        }
-                         
-                        le = le->Flink;
-                    }
-                    
-                    if (!found) {
-                        fcb* fcb;
-                        file_ref* fr;
-                        ANSI_STRING xattr;
-                        ULONG stringlen;
-                        
-                        xattr.Length = xa->n;
-                        xattr.MaximumLength = xattr.Length + 1;
-                        xattr.Buffer = ExAllocatePoolWithTag(PagedPool, xattr.MaximumLength, ALLOC_TAG);
-                        
-                        if (!xattr.Buffer) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        RtlCopyMemory(xattr.Buffer, xa->name, xa->n);
-                        xattr.Buffer[xa->n] = 0;
-                        
-                        Status = open_fcb_stream(me->fileref->fcb->Vcb, me->fileref->fcb->subvol, me->fileref->fcb->inode, &xattr,
-                                                 tp.item->key.offset, me->fileref->fcb, &fcb, Irp);
-                        
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("open_fcb_stream returned %08x\n", Status);
-                            ExFreePool(xattr.Buffer);
-                            goto end;
-                        }
-                        
-                        fr = create_fileref();
-                        if (!fr) {
-                            ERR("out of memory\n");
-                            free_fcb(fcb);
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        fr->fcb = fcb;
-                        
-                        Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, &xa->name[xapreflen], xa->n - xapreflen);
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, stringlen, ALLOC_TAG);
-                        if (!fr->filepart.Buffer) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        Status = RtlUTF8ToUnicodeN(fr->filepart.Buffer, stringlen, &stringlen, &xa->name[xapreflen], xa->n - xapreflen);
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        fr->filepart.Length = fr->filepart.MaximumLength = stringlen;
-                        
-                        Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-                            free_fileref(fr);
-                            goto end;
-                        }
-
-                        fr->parent = (struct _file_ref*)me->fileref;
-                        increase_fileref_refcount(fr->parent);
-                        
-                        insert_fileref_child(me->fileref, fr, FALSE);
-
-                        me2 = ExAllocatePoolWithTag(PagedPool, sizeof(move_entry), ALLOC_TAG);
-                        if (!me2) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        me2->fileref = fr;
-                        me2->dummyfcb = NULL;
-                        me2->dummyfileref = NULL;
-                        me2->parent = me;
-                        
-                        InsertHeadList(&me->list_entry, &me2->list_entry);
-                    }
-                }
-                
-                len -= sizeof(DIR_ITEM) - 1 + xa->m + xa->n;
-                
-                if (len > 0)
-                    xa = (DIR_ITEM*)&xa->name[xa->m + xa->n];
-            } while (len > 0);
-        }
+        Status = open_fileref_child(Vcb, me->fileref, &dc->name, TRUE, TRUE, dc->index == 0 ? TRUE : FALSE, PagedPool, &fr, Irp);
         
-        b = find_next_item(me->fileref->fcb->Vcb, &tp, &next_tp, FALSE, Irp);
-        if (b) {
-            tp = next_tp;
-            
-            if (next_tp.item->key.obj_id > searchkey.obj_id || (next_tp.item->key.obj_id == searchkey.obj_id && next_tp.item->key.obj_type > searchkey.obj_type))
-                break;
+        if (!NT_SUCCESS(Status)) {
+            ERR("open_fileref_child returned %08x\n", Status);
+            ExReleaseResourceLite(&me->fileref->fcb->nonpaged->dir_children_lock);
+            return Status;
         }
-    } while (b);
-    
-    if (me->fileref->fcb->type == BTRFS_TYPE_DIRECTORY && me->fileref->fcb->inode_item.st_size != 0) {
-        searchkey.obj_id = me->fileref->fcb->inode;
-        searchkey.obj_type = TYPE_DIR_INDEX;
-        searchkey.offset = 2;
         
-        Status = find_item(me->fileref->fcb->Vcb, me->fileref->fcb->subvol, &tp, &searchkey, FALSE, Irp);
-        if (!NT_SUCCESS(Status)) {
-            ERR("error - find_item returned %08x\n", Status);
-            goto end;
+        me2 = ExAllocatePoolWithTag(PagedPool, sizeof(move_entry), ALLOC_TAG);
+        if (!me2) {
+            ERR("out of memory\n");
+            ExReleaseResourceLite(&me->fileref->fcb->nonpaged->dir_children_lock);
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        do {
-            traverse_ptr next_tp;
-            
-            // FIXME - both lists are ordered; we can make this more efficient
-            
-            if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
-                BOOL found = FALSE;
-                
-                le = me->fileref->children.Flink;
-                
-                while (le != &me->fileref->children) {
-                    file_ref* fr = CONTAINING_RECORD(le, file_ref, list_entry);
-                    
-                    if (!fr->fcb->ads) {
-                        if (fr->index == tp.item->key.offset) {
-                            found = TRUE;
-                            break;
-                        } else if (fr->index > tp.item->key.offset)
-                            break;
-                    }
-                    
-                    le = le->Flink;
-                }
-                
-                if (!found) {
-                    DIR_ITEM* di = (DIR_ITEM*)tp.item->data;
-                    
-                    if (tp.item->size < sizeof(DIR_ITEM)) {
-                        ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
-                        Status = STATUS_INTERNAL_ERROR;
-                        goto end;
-                    }
-                    
-                    if (tp.item->size < sizeof(DIR_ITEM) - 1 + di->m + di->n) {
-                        ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM) - 1 + di->m + di->n);
-                        Status = STATUS_INTERNAL_ERROR;
-                        goto end;
-                    }
-                    
-                    if (di->n == 0) {
-                        ERR("(%llx,%x,%llx): filename length was 0\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                        Status = STATUS_INTERNAL_ERROR;
-                        goto end;
-                    }
-                    
-                    if (di->key.obj_type == TYPE_INODE_ITEM || di->key.obj_type == TYPE_ROOT_ITEM) {
-                        ANSI_STRING utf8;
-                        fcb* fcb;
-                        file_ref* fr;
-                        ULONG stringlen;
-                        root* subvol;
-                        UINT64 inode;
-                        dir_child* dc = NULL;
-                        
-                        utf8.Length = utf8.MaximumLength = di->n;
-                        utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.MaximumLength, ALLOC_TAG);
-                        if (!utf8.Buffer) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        RtlCopyMemory(utf8.Buffer, di->name, di->n);
-                        
-                        if (di->key.obj_type == TYPE_ROOT_ITEM) {
-                            LIST_ENTRY* le2;
-                            
-                            subvol = NULL;
-                            
-                            le2 = me->fileref->fcb->Vcb->roots.Flink;
-                            while (le2 != &me->fileref->fcb->Vcb->roots) {
-                                root* r2 = CONTAINING_RECORD(le2, root, list_entry);
-                                
-                                if (r2->id == di->key.obj_id) {
-                                    subvol = r2;
-                                    break;
-                                }
-                                
-                                le2 = le2->Flink;
-                            }
-                            
-                            if (!subvol) {
-                                ERR("could not find subvol %llx\n", di->key.obj_id);
-                                Status = STATUS_INTERNAL_ERROR;
-                                goto end;
-                            }
+        me2->fileref = fr;
+        me2->dummyfcb = NULL;
+        me2->dummyfileref = NULL;
+        me2->parent = me;
 
-                            inode = SUBVOL_ROOT_INODE;
-                        } else {
-                            subvol = me->fileref->fcb->subvol;
-                            inode = di->key.obj_id;
-                        }
-                        
-                        Status = open_fcb(me->fileref->fcb->Vcb, subvol, inode, di->type, &utf8, me->fileref->fcb, &fcb, PagedPool, Irp);
-                        
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("open_fcb returned %08x\n", Status);
-                            ExFreePool(utf8.Buffer);
-                            goto end;
-                        }
-                        
-                        fr = create_fileref();
-                        if (!fr) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(utf8.Buffer);
-                            free_fcb(fcb);
-                            goto end;
-                        }
-                        
-                        fr->fcb = fcb;
-                        fr->utf8 = utf8;
-                        
-                        Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, utf8.Buffer, utf8.Length);
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, stringlen, ALLOC_TAG);
-                        if (!fr->filepart.Buffer) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        Status = RtlUTF8ToUnicodeN(fr->filepart.Buffer, stringlen, &stringlen, utf8.Buffer, utf8.Length);
-                        
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        fr->filepart.Length = fr->filepart.MaximumLength = stringlen;
-                        
-                        Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
-                        
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        fr->parent = me->fileref;
-
-                        fr->index = tp.item->key.offset;
-                        increase_fileref_refcount(me->fileref);
-                        
-                        Status = add_dir_child(me->fileref->fcb, di->key.obj_type == TYPE_ROOT_ITEM ? subvol->id : fr->fcb->inode,
-                                               di->key.obj_type == TYPE_ROOT_ITEM ? TRUE : FALSE, fr->index, &utf8, &fr->filepart, &fr->filepart_uc, BTRFS_TYPE_DIRECTORY, &dc);
-                        if (!NT_SUCCESS(Status))
-                            WARN("add_dir_child returned %08x\n", Status);
-                        
-                        fr->dc = dc;
-                        dc->fileref = fr;
-                        
-                        insert_fileref_child(fr->parent, fr, FALSE);
-                        
-                        if (fr->fcb->type == BTRFS_TYPE_DIRECTORY)
-                            fr->fcb->fileref = fr;
-                        
-                        me2 = ExAllocatePoolWithTag(PagedPool, sizeof(move_entry), ALLOC_TAG);
-                        if (!me2) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            free_fileref(fr);
-                            goto end;
-                        }
-                        
-                        me2->fileref = fr;
-                        me2->dummyfcb = NULL;
-                        me2->dummyfileref = NULL;
-                        me2->parent = me;
-                        
-                        InsertHeadList(&me->list_entry, &me2->list_entry);
-                    } else {
-                        ERR("unrecognized key (%llx,%x,%llx)\n", di->key.obj_id, di->key.obj_type, di->key.offset);
-                        Status = STATUS_INTERNAL_ERROR;
-                        goto end;
-                    }
-                }
-            }
-            
-            b = find_next_item(me->fileref->fcb->Vcb, &tp, &next_tp, FALSE, Irp);
-            if (b) {
-                tp = next_tp;
-                
-                if (next_tp.item->key.obj_id > searchkey.obj_id || (next_tp.item->key.obj_id == searchkey.obj_id && next_tp.item->key.obj_type > searchkey.obj_type))
-                    break;
-            }
-        } while (b);
+        InsertHeadList(&me->list_entry, &me2->list_entry);
+        
+        le = le->Flink;
     }
     
-    Status = STATUS_SUCCESS;
+    ExReleaseResourceLite(&me->fileref->fcb->nonpaged->dir_children_lock);
     
-end:
-    ExReleaseResourceLite(&me->fileref->nonpaged->children_lock);
-    
-    return Status;
+    return STATUS_SUCCESS;
 }
 
 void remove_dir_child_from_hash_lists(fcb* fcb, dir_child* dc) {
@@ -917,7 +542,7 @@
     RemoveEntryList(&dc->list_entry_hash_uc);
 }
 
-static NTSTATUS move_across_subvols(file_ref* fileref, file_ref* destdir, PANSI_STRING utf8, PUNICODE_STRING fnus, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS move_across_subvols(file_ref* fileref, ccb* ccb, file_ref* destdir, PANSI_STRING utf8, PUNICODE_STRING fnus, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     LIST_ENTRY move_list, *le;
     move_entry* me;
@@ -927,6 +552,9 @@
     
     InitializeListHead(&move_list);
     
+    KeQuerySystemTime(&time);
+    win_time_to_unix(time, &now);
+    
     me = ExAllocatePoolWithTag(PagedPool, sizeof(move_entry), ALLOC_TAG);
     
     if (!me) {
@@ -952,7 +580,7 @@
         ExAcquireResourceSharedLite(me->fileref->fcb->Header.Resource, TRUE);
         
         if (!me->fileref->fcb->ads && me->fileref->fcb->subvol == origparent->fcb->subvol) {
-            Status = add_children_to_move_list(me, Irp);
+            Status = add_children_to_move_list(fileref->fcb->Vcb, me, Irp);
             
             if (!NT_SUCCESS(Status)) {
                 ERR("add_children_to_move_list returned %08x\n", Status);
@@ -965,6 +593,8 @@
         le = le->Flink;
     }
     
+    send_notification_fileref(fileref, fileref->fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED);
+    
     // loop through list and create new inodes
     
     le = move_list.Flink;
@@ -975,7 +605,7 @@
             if (!me->dummyfcb) {
                 ULONG defda;
                 BOOL inserted = FALSE;
-                LIST_ENTRY* le;
+                LIST_ENTRY* le3;
                 
                 ExAcquireResourceExclusiveLite(me->fileref->fcb->Header.Resource, TRUE);
                 
@@ -1009,8 +639,9 @@
                     me->fileref->fcb->inode = InterlockedIncrement64(&destdir->fcb->subvol->lastinode);
                     me->fileref->fcb->inode_item.st_nlink = 1;
                     
-                    defda = get_file_attributes(me->fileref->fcb->Vcb, &me->fileref->fcb->inode_item, me->fileref->fcb->subvol, me->fileref->fcb->inode,
-                                                me->fileref->fcb->type, me->fileref->filepart.Length > 0 && me->fileref->filepart.Buffer[0] == '.', TRUE, Irp);
+                    defda = get_file_attributes(me->fileref->fcb->Vcb, me->fileref->fcb->subvol, me->fileref->fcb->inode,
+                                                me->fileref->fcb->type, me->fileref->dc && me->fileref->dc->name.Length >= sizeof(WCHAR) && me->fileref->dc->name.Buffer[0] == '.',
+                                                TRUE, Irp);
                     
                     me->fileref->fcb->sd_dirty = !!me->fileref->fcb->sd;
                     me->fileref->fcb->atts_changed = defda != me->fileref->fcb->atts;
@@ -1019,13 +650,20 @@
                     me->fileref->fcb->ea_changed = !!me->fileref->fcb->ea_xattr.Buffer;
                     me->fileref->fcb->inode_item_changed = TRUE;
                     
+                    if (le == move_list.Flink) { // first entry
+                        me->fileref->fcb->inode_item.transid = me->fileref->fcb->Vcb->superblock.generation;
+                        me->fileref->fcb->inode_item.sequence++;
+
+                        if (!ccb->user_set_change_time)
+                            me->fileref->fcb->inode_item.st_ctime = now;
+                    }
+                    
                     le2 = me->fileref->fcb->extents.Flink;
                     while (le2 != &me->fileref->fcb->extents) {
                         extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
                         
-                        if (!ext->ignore && ext->datalen >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2) &&
-                            (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC)) {
-                            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
+                        if (!ext->ignore && (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC)) {
+                            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
                                         
                             if (ed2->size != 0) {
                                 chunk* c = get_chunk_from_address(me->fileref->fcb->Vcb, ed2->address);
@@ -1058,17 +696,17 @@
                 InsertHeadList(&me->fileref->fcb->list_entry, &me->dummyfcb->list_entry);
                 RemoveEntryList(&me->fileref->fcb->list_entry);
                 
-                le = destdir->fcb->subvol->fcbs.Flink;
-                while (le != &destdir->fcb->subvol->fcbs) {
-                    fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry);
+                le3 = destdir->fcb->subvol->fcbs.Flink;
+                while (le3 != &destdir->fcb->subvol->fcbs) {
+                    fcb* fcb = CONTAINING_RECORD(le3, struct _fcb, list_entry);
                     
                     if (fcb->inode > me->fileref->fcb->inode) {
-                        InsertHeadList(le->Blink, &me->fileref->fcb->list_entry);
+                        InsertHeadList(le3->Blink, &me->fileref->fcb->list_entry);
                         inserted = TRUE;
                         break;
                     }
                     
-                    le = le->Flink;
+                    le3 = le3->Flink;
                 }
                 
                 if (!inserted)
@@ -1077,8 +715,7 @@
                 InsertTailList(&me->fileref->fcb->Vcb->all_fcbs, &me->dummyfcb->list_entry_all);
                 
                 while (!IsListEmpty(&me->fileref->fcb->hardlinks)) {
-                    LIST_ENTRY* le = RemoveHeadList(&me->fileref->fcb->hardlinks);
-                    hardlink* hl = CONTAINING_RECORD(le, hardlink, list_entry);
+                    hardlink* hl = CONTAINING_RECORD(RemoveHeadList(&me->fileref->fcb->hardlinks), hardlink, list_entry);
                     
                     if (hl->name.Buffer)
                         ExFreePool(hl->name.Buffer);
@@ -1119,9 +756,6 @@
         le = le->Flink;
     }
     
-    KeQuerySystemTime(&time);
-    win_time_to_unix(time, &now);
-    
     fileref->fcb->subvol->root_item.ctransid = fileref->fcb->Vcb->superblock.generation;
     fileref->fcb->subvol->root_item.ctime = now;
     
@@ -1134,7 +768,7 @@
         
         me = CONTAINING_RECORD(le, move_entry, list_entry);
         
-        me->dummyfileref = create_fileref();
+        me->dummyfileref = create_fileref(fileref->fcb->Vcb);
         if (!me->dummyfileref) {
             ERR("out of memory\n");
             Status = STATUS_INSUFFICIENT_RESOURCES;
